<?php

class LdapDataController extends EntityAPIController {

  public function save($entity) {
    drupal_write_record('ldap_data', $entity, $entity->op == 'Update' ? array($this->idKey) : array());
    field_attach_insert('ldap_data', $entity);  // prescindible si ! fieldable ??
    module_invoke_all($entity->op == 'Update' ? 'entity_update' : 'entity_insert', $entity, 'ldap_data');
    return $entity;
  }

  public function delete($did) {
    if (empty($did)) {
      return;
    }
    $ldap_data = ldap_data_load($did);
    if (empty($ldap_data)) {
      return;
    }

    $transaction = db_transaction();
    try {
      module_invoke_all('entity_delete', $ldap_data, 'ldap_data');
      field_attach_delete('ldap_data', $ldap_data);

      db_delete('ldap_data')
        ->condition('did', $did)
        ->execute();
    }
    catch (Exception $e) {
      $transaction->rollback();
      watchdog_exception('user', $e);
      throw $e;
    }
  }
}