<?php
// $Id: ldap_servers.theme.inc,v 1.4.2.1 2011/02/08 20:05:41 johnbarclay Exp $


/**
 * @file
 * theming functions for ldap_data module
 *
 */


/**
 * Returns HTML for ldap search.
 *
 * @param $variables
 *   An associative array containing:
 *   - ldap_data: an array of one or more ldap data.
 *   - actions:  true or false indicating include update, delete, etc. links
 *   - type:  'table', 'list', etc for style to render
 *
 * @ingroup themeable
 */

function theme_ldap_data_search($variables) {
  $ldap_data = $variables['ldap_data'];
  require_once('ldap_data.install');
  $schema = ldap_data_schema();
  foreach ($schema['ldap_data']['fields'] as $field => $value) {
      $items[] = "$field: " . (is_array($ldap_data->$field) ? implode(', ', $ldap_data->$field) : $ldap_data->$field);
  }

  return theme_item_list(
    array(
      'items' => $items,
      'type' => 'ul',
      'title' => '',
      'attributes' => array()
      )
    );
}


